; =======================================================================
; Shell32 UDF 1.0.0.2 - 2.12.07 by Kre Johansson
; Requerement Shell.Application component
; Global Constans: none
; Functions: 	_OpenFolder($app='',$mode=0)
;				_OpenDialog($app=0,$mode=0)
;				_OpenWizard($app='?')
;				_OrginizeWindows($mode)
;				_CreateShortcut($sDir="Desktop",$sDesc="Shortcut Script",$sTarget="Notepad.exe",$sKey="",$sIcon="notepad.exe,0")
;				_ArrangeIEFavorites($iMode=0,$sUrl='',$sTx='MyFavorite')
;				_OpenChm($sFile,$sHtm='',$mode=0)
; =======================================================================
#include-once

; =======================================================================
; _OpenDrawer 1.0.0.0 - 26.11.07
; argument drawer,explorer / Bool mode return no
; =======================================================================
Func _OpenFolder($app='',$mode=0)
Local $oRP = ObjCreate("shell.application")
If Not IsObj($oRP) Or Not Fileexists($app) Then Return MsgBox(64,"ERROR...","shell application object failure...")
With $oRP
	If $mode = 0 Then
		.Open($app)
	Else
		.Explore($app)
	EndIf
EndWith
$oRP = 0
EndFunc

; =======================================================================
; _OpenRequest 1.0.0.0 - 27.11.07
; argument dialog windows / Return no
; =======================================================================
Func _OpenDialog($app=0,$mode=0)
Local $oRP = ObjCreate("shell.application"),$a = '/n'
If Not IsObj($oRP) Or $app = '' Then Return MsgBox(64,"ERROR...","shell application object failure...")
With $oRP
	Switch $app
		Case 1
			.FindFiles
		Case 2
			.FindComputer
		Case 3
			.FileRun
		Case 4
			.SetTime
		Case 5
			.TrayProperties
		Case 6
			.Help
		Case 7
			.ShutdownWindows
		Case 8
			Switch $mode
				Case 1
					$a = '/s'
				Case 2
					$a = '/t'
				Case 3
					$a = '/r'
			EndSwitch
			ShellExecute("sndvol32.exe",$a,@SystemDir)
		Case 9
			ShellExecute("sndrec32.exe","",@SystemDir)
	EndSwitch
EndWith
$oRP = 0
EndFunc

; =======================================================================
; _OpenWizard 1.0.0.0 - 28.11.07
; argument Requester / Return no
; =======================================================================
Func _OpenWizard($app='?')
Local $oRP = ObjCreate("shell.application"),$fil = @SystemDir & '\' & $app,$ret
If Not IsObj($oRP) Or $app = '' Then Return MsgBox(64,"ERROR...","shell application object failure...")
If StringInStr($fil,'.',2) = 0 Then $fil = $fil & '.cpl'
If Not FileExists($fil) Then
	$oRP = 0
	Local $sea = FileFindFirstFile(@SystemDir & '\*.cpl')  
	If $sea = -1 Then Return 1
	While 1
		$app = FileFindNextFile($sea) 
		If @error Then ExitLoop
		$ret = $ret & StringInStr($app,'.',2)-1 & '|'
		ConsoleWrite(StringMid($app,1,StringInStr($app,'.',2)-1) & @CRLF)
	WEnd
	FileClose($sea)
	Return StringSplit(StringLeft($ret,StringLen($ret)-1),'|')
EndIf
With $oRP
	.ControlPanelItem($fil)
EndWith
$oRP = 0
EndFunc

; =======================================================================
; _OrginizeWindows 1.0.0.0 - 28.11.07
; argument mode / Return no
; =======================================================================
Func _OrginizeWindows($mode)
Local $oRP = ObjCreate("shell.application"),$err = 0
If Not IsObj($oRP) Then Return MsgBox(64,"ERROR...","shell application object failure...")
With $oRP
	Switch $mode
		Case 1
			.TileVertically
		Case 2
			.TileHorizontally
		Case 3
			.CascadeWindows
		Case 4
			.MinimizeAll
		Case 5
			.UndoMinimizeALL
		Case Else
			$err = 1
	EndSwitch
EndWith
$oRP = 0
Return $err
EndFunc

; =======================================================================
; _CreateShortcut 1.0.0.0 - 29.11.07
; argument mode / Return no
; =======================================================================
Func _CreateShortcut($sDir="Desktop",$sDesc="Shortcut Script",$sTarget="Notepad.exe",$sKey="",$sIcon="notepad.exe,0")
Local $WShell = ObjCreate("WScript.Shell")
If Not IsObj($WShell) Then Return MsgBox(64,"ERROR...","WScript shell object failure...")
With $WShell
	Local $str = .SpecialFolders($sDir)
	Local $oLink = .CreateShortcut($str & "\\" & $sDesc & ".lnk")
         $oLink.TargetPath = $sTarget
         $oLink.WindowStyle = 1 ; 1 3 7
         If $sKey <> '' Then $oLink.Hotkey = $sKey
         $oLink.IconLocation = $sIcon
         $oLink.Description = $sDesc
         $oLink.WorkingDirectory = $str
         $oLink.Save
EndWith
$WShell = 0
EndFunc

; =======================================================================
; _ArrangeIEFavorites 1.0.0.0 - 30.11.07
; argument mode, Url, txt [ optional ] / Return no
; =======================================================================
Func _ArrangeIEFavorites($iMode=0,$sUrl='',$sTx='MyFavorite')
Local $ShellUI = ObjCreate("Shell.UIHelper")
If Not IsObj($ShellUI) Then Return MsgBox(64,"ERROR...","UIHelper shell object failure...")
With $ShellUI
	If $iMode Or $sUrl = '' Then
		.ShowBrowserUI("OrganizeFavorites",0)
	Else
		If $sUrl <> '' Then .addfavorite($sUrl,$sTx)
	EndIf
EndWith
$ShellUI = 0
EndFunc

; =======================================================================
; _OpenChm 1.0.0.0 - 30.11.07
; argument Chm file, Chm htm node [ optional ], run mode bool [ optional ] / Return 1 as succes
; =======================================================================
Func _OpenChm($sFile,$sHtm='',$mode=0)
Local $hh = @SystemDir & '\hh.exe'
If Not FileExists($hh) or Not FileExists($sFile) Then Return MsgBox(64,"ERROR...","HH.exe or Chm failure...")
If $sHtm <> '' Then $sFile = $sFile & '::/' & $sHtm
	If $mode Then
		ShellExecuteWait($hh,$sFile,StringMid($sFile,1,StringInStr($sFile,'/',2,-1)), "open")
	Else
		ShellExecute($hh,$sFile,StringMid($sFile,1,StringInStr($sFile,'/',2,-1)), "open")
	EndIf
EndFunc
