#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Run_Tidy=y
#Tidy_Parameters=/sf
#AutoIt3Wrapper_Res_Fileversion=0.1.2.0
#AutoIt3Wrapper_Res_SaveSource=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------
	
	AutoIt Version: 			3.2.10.0
	
	Script Name:				_AdminTray.au3 - Functions for Admin Tray
	http://www.autoitscript.com/forum/index.php?showtopic=58997
	
	Author:						James R Feig III
	AutoITScript.com Forum id:	toyotabedzrock
	
	_XMLDomWrapper.au3 	BY:		ElTorro
	http://www.autoitscript.com/forum/index.php?showtopic=19848
	
	ModernMenu.au3 		BY:		Holger
	http://www.autoitscript.com/forum/index.php?showtopic=20967&hl=systray
	
	Shell32.au3			BY:		kjactive
	http://www.autoitscript.com/forum/index.php?showtopic=58940
	
	Script Function:
	Parse XML file and creates a tray menu with icons.
	Also allows you to execute single commands in AutoIT i.e. _OpenDialog(3) for the run box. See Exit and Run commands in the XML file for proper formating.
	
#ce ----------------------------------------------------------------------------
#include-once

Global Const $xmlBasePath = "/Tray"
Global Const $xmlMenuPath = "/Menu"
Global Const $xmlItemPath = "/Item"
Global Const $xmlIconPath = "/Icon"

Global Const $xmlMenu = "Menu"
Global Const $xmlItem = "Item"
Global Const $xmlIcon = "Icon"
Global Const $xmlSpacer = "Spacer"

Global Const $autoitCommand = "AutoIT"
Global Const $commandWithArguments = "Arg"
Global Const $commandDelimiter = "[|]"


Func _Exit()
	
	_TrayIconDelete($aTray)

	Exit
	
EndFunc   ;==>_Exit

Func _Parse(ByRef $trayItems, $cPath = $xmlBasePath, $mIndex = 0)
	
	Dim $ii = 1, $im = 1
	$cElements = _XMLSelectNodes($cPath & "/*")
	
	For $i = 1 To $cElements[0]
		
		$cParPath = $cPath
		
		Switch $cElements[$i]
			
			Case $xmlMenu
				
				$cParPath = $cParPath & $xmlMenuPath & "[" & $im & "]"
				
				_Parse($trayItems, $cParPath, _readMenu($trayItems, $cParPath, $mIndex))
				
				$im = $im + 1

			Case $xmlItem
				
				$cParPath = $cParPath & $xmlItemPath & "[" & $ii & "]"
				
				_Parse($trayItems, $cParPath, _readItems($trayItems, $mIndex, $cParPath))
				
				$ii = $ii + 1
				
			Case $xmlSpacer
				
				_traySpacer($mIndex)
				
			Case $xmlIcon
				
				_readIcon($cPath & $xmlIconPath)
				
		EndSwitch
		
	Next
	
	Return 0

EndFunc   ;==>_Parse

Func _readIcon($cPath)
	
	If $cPath = ($xmlBasePath & $xmlIconPath) Then
		
		$aTray = _TrayIconCreate(_XMLGetAttrib($xmlBasePath, "Label"), _XMLGetAttrib($cPath, "File"), Number(_XMLGetAttrib($cPath, "Position")))
		
	Else
		
		_TrayItemSetIcon(-1, _XMLGetAttrib($cPath, "File"), Number(_XMLGetAttrib($cPath, "Position")))
		
	EndIf

EndFunc   ;==>_readIcon


Func _readItems(ByRef $itemArray, $mIndex, $cPath)
	
	ReDim $itemArray[($itemArray[0][0] + 1)][2]
	$itemArray[$itemArray[0][0]][0] = _TrayCreateItem(-1, _XMLGetAttrib($cPath, "Label"), $mIndex)
	$itemArray[$itemArray[0][0]][1] = _XMLGetAttrib($cPath, "Command")
	$itemArray[0][0] = $itemArray[0][0] + 1

	Return 0
	
EndFunc   ;==>_readItems

Func _readMenu(ByRef $itemArray, $cPath, $mIndex)

	$trayMenu = _TrayCreateMenu(-1, _XMLGetAttrib($cPath, "Label"), $mIndex)
	
	Return $trayMenu
	
EndFunc   ;==>_readMenu

Func _runCommand($command)
	
	$funcCommand = StringSplit($command, $commandDelimiter, 1)
	
	Switch $funcCommand[1]
		
		Case $autoitCommand
			
			Execute($funcCommand[2])
			
		Case $commandWithArguments
			
			Switch $funcCommand[0]
				
				Case 4
					
					ShellExecute($funcCommand[2], $funcCommand[3], "", "", $funcCommand[4])
					
				Case 3
					
					ShellExecute($funcCommand[2], $funcCommand[3])
					
			EndSwitch
			
		Case Else
			
			ShellExecute($funcCommand[1])
			
	EndSwitch
	
EndFunc   ;==>_runCommand

Func _traySpacer($mIndex)
	
	_TrayCreateItem(-1, "", $mIndex)
	_TrayItemSetIcon(-1, "", 0)
	
	Return 0
	
EndFunc   ;==>_traySpacer